import java.util.Iterator;
import java.util.Vector;

public class TreeIterator<K extends Comparable<? super K>, V> implements Iterator<TreeItem<K, V>> {

	BinarySearchTree<K, V> bst;
	Vector<TreeNode<K, V>> treeNodes;
	
	public TreeIterator(BinarySearchTree<K, V> bst) {
		this.bst = bst;
	}
	
	public void setInOrder() {
		this.treeNodes = new Vector<TreeNode<K, V>>();
		this.inOrder(bst.getRoot());
		System.out.println("Nodes in the tree = " + this.treeNodes.size());
	}
	
	public void setPreOrder() {
		this.treeNodes = new Vector<TreeNode<K, V>>();
		this.preOrder(bst.getRoot());
		System.out.println("Nodes in the tree = " + this.treeNodes.size());
	}
	
	public void setPostOrder() {
		this.treeNodes = new Vector<TreeNode<K, V>>();
		this.postOrder(bst.getRoot());
		System.out.println("Nodes in the tree = " + this.treeNodes.size());
	}
	
	@Override
	public boolean hasNext() {
		if (this.treeNodes == null) {
			return false;
		} else {
			return !this.treeNodes.isEmpty();
		}
	}

	@Override
	public TreeItem<K, V> next() {
		TreeItem<K, V> item = this.treeNodes.elementAt(0).getTreeItem();
		this.treeNodes.remove(0);
		if (this.treeNodes.isEmpty()) {
			this.treeNodes = null;
		}
		return item;
	}

	private void inOrder(TreeNode<K, V> node) {
		if (node != null) {
			inOrder(node.getLeftChild());
			this.treeNodes.add(node);
			inOrder(node.getRightChild());
		}
	}

	private void preOrder(TreeNode<K, V> node) {
		if (node != null) {
			this.treeNodes.add(node);
			preOrder(node.getLeftChild());
			preOrder(node.getRightChild());
		}
	}

	private void postOrder(TreeNode<K, V> node) {
		if (node != null) {
			postOrder(node.getLeftChild());
			postOrder(node.getRightChild());
			this.treeNodes.add(node);
		}
	}
	
	
}
